SystemOrganization addCategory: #'GBT-DSL_BuddyWallet'!

Object subclass: #BuddyWallet
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_BuddyWallet'!

!BuddyWallet class methodsFor: 'example' stamp: 'hk 4/27/2017 18:57'!
buddyWallet
	^self new buddyWallet! !

!BuddyWallet class methodsFor: 'example' stamp: 'hk 4/27/2017 18:32'!
clear
	GbtSVO initialize. 
	GbtBizAppServer clear
! !

!BuddyWallet class methodsFor: 'example' stamp: 'hk 4/27/2017 18:46'!
exampleData
	GbtBizAppServer clearStore. 
	self new storeAccounts  ! !

!BuddyWallet class methodsFor: 'example' stamp: 'hk 4/27/2017 18:56'!
exampleRun
	(self clear; buddyWallet) open
! !

!BuddyWallet class methodsFor: 'example' stamp: 'hk 4/27/2017 18:58'!
exampleRunLogin
	self clear.
	self new installUsers login open
! !

!BuddyWallet methodsFor: 'things' stamp: 'hk 4/28/2017 12:46'!
account
	"self new account"
	self ensureCompilation .
	^GbtThing copy: 'Account'! !

!BuddyWallet methodsFor: 'test data' stamp: 'hk 4/24/2017 16:04'!
account01
	"self new account01 edit"
	^self account
		bizId: self nextBizID;
		nick: #firstAccount;
		IBAN: 'DE51 1234 5678 9876 5432' ;	
		amount: 1000;
		firstName: #Lisa ;
		lastName: #Schmitz;
		eMail: 'Lisa.Schmitz@web.de';
		yourself.

! !

!BuddyWallet methodsFor: 'test data' stamp: 'hk 4/24/2017 16:05'!
account02
	"self new account02 edit"
	^self account
		bizId: self nextBizID;
		IBAN: 'DE51 1005 0500 9876 1234' ;	
		amount: 500;
		firstName: #Tom ;
		lastName: #Taylor;
		eMail: 'Tom.Taylor@gmx.net';
		yourself! !

!BuddyWallet methodsFor: 'test data' stamp: 'hk 4/24/2017 16:05'!
account03
	"self new account03 edit"
	^self account
		bizId: self nextBizID;
		IBAN: 'DE51 1005 0500 0054 1234' ;	
		amount: 1000;
		firstName: #Helmut ;
		lastName: #Lange;
		eMail: 'Helmut@Lange.de';
		yourself! !

!BuddyWallet methodsFor: 'test data' stamp: 'hk 4/24/2017 16:04'!
account04
	^self account
		bizId: self nextBizID;
		IBAN: 'DE51 1005 0500 0045 9876';
		nick: #otherAccount;
		amount: -500;
		firstName: #Lisa;
		lastName: #Schmitz;
		eMail: 'Lisa.Schmitz@web.de';
		yourself! !

!BuddyWallet methodsFor: 'test data' stamp: 'hk 4/24/2017 16:05'!
account05
	"self new account05 edit"
	^self account
		bizId: self nextBizID;
		IBAN: 'DE51 1005 0500 9999 7777' ;	
		amount: 800;
		firstName: #Helmut ;
		lastName: #Schmidt;
		eMail: 'Helmut@Schmidt.de';
		yourself! !

!BuddyWallet methodsFor: 'contexts' stamp: 'hk 4/24/2017 18:10'!
buddies 
	^GbtBigListAC struct: 'Buddies' define: {
		{#displayAs: . 'Buddies'} .
		{#uiSpec:icon: . #GbtListUI . #crm} .
		{#templates: . self account} .
		{#loadPolicy: . #autoload } .
		{#display: . #(firstName eMail)} .
	}! !

!BuddyWallet methodsFor: 'contexts' stamp: 'hk 3/31/2017 13:57'!
buddyWallet  
	"self new buddyWallet open" 

	^GbtPlainAC struct: 'BuddyWallet' define: {
		{#aspect:on: . self myAccounts . #nil  } .
		{#aspect:on: . self buddies . #nil  } .
		{#aspect:on: . self transfers . #nil  } .
		{#uiSpec:icon: . #GbtMainUI . #walletBig} .
		{#extent: . (800 @ 600)}.
	}! !

!BuddyWallet methodsFor: 'functions' stamp: 'hk 4/24/2017 18:14'!
declaratives
	"takes as source i) the transformed source, ii) the transfer order and iii) the transfer thing "
	GbtDeclarative struct: 'SourceDecl' define: {
		{ #oldSourceAmount . #tag: . #amount }.
		{ #dispo } .
		{ #transferLimit} .
	}.
	
	GbtDeclarative struct: 'SinkDecl' define: {
		{ #oldSinkAmount . #tag: .#amount } 
	}.
		
	GbtThing struct: 'Transfer' define: {
		{ #newSourceAmount . #calc: . '#oldSourceAmount - #transferAmount' }.
		{ #newSinkAmount . #calc: . '#oldSinkAmount + #transferAmount' } .
		{ #limitConstraint . #constraint:ifViolated: . '#transferAmount asNumber < #transferLimit asNumber' . 'limit exceeded'} .
		{ #dispoConstraint . #constraint:ifViolated: . '#oldSourceAmount asNumber - #transferAmount asNumber + #dispo asNumber >= 0' . 'no balace cover'} .
	}.
	
	^GbtDeclarative struct: 'Transfer' define: {
		{ #oldSourceAmount }.
		{ #oldSinkAmount }.
		{ #dispo } .
		{ #transferLimit} .
		{ #transferAmount} 
	}.
! !

!BuddyWallet methodsFor: 'functions' stamp: 'hk 4/27/2017 17:53'!
doitBehavior: behName  
	^GbtBehavior newStruct: behName arguments: #() define: #(
		READSLOT #(source vSourceNick)							"get the source nickname - as edited by user"
		READSLOT #(target vTargetEmail)						"get the target email - as edited by user"
		ASKROLE #(MyAccounts vSourceNick transferSource) 	"get  accounts for source - do not copy"
		ASKROLE #(Buddies vTargetEmail transferSink) 		"and target into the roles - do not copy"
		TRANSFORM #(transferSource SourceDecl sourceVar)	"get a.o. the source amount"
		TRANSFORM #(transferSink SinkDecl sinkVar)			"and the sink amount"
		COMPOSE #(Transfer sourceVar	sinkVar)				"make the core tx thing with the pool thing,too"						
		CHECK #transferCheck 										"check contraints"
		READSLOT #(newSourceAmount newSourceA) 				"read the final"
		READSLOT #(newSinkAmount newSinkA) 					"account values"
		WRITESLOT #(newSourceA transferSource amount) 		"write them"
		WRITESLOT #(newSinkA transferSink amount) 			"into the accounts"
		SAVECONTEXT #(transferSource Buddies)				"shall be saved in MyAccounts AND Buddies"
		SAVECONTEXT #(transferSink MyAccounts)				"shall be saved in MyAccounts AND Buddies"
		COMMIT #void 												"commit the tx"
		ASSIGNTODAY #(contextVO date)
	)! !

!BuddyWallet methodsFor: 'things' stamp: 'hk 4/28/2017 12:18'!
ensureCompilation
	GbtBizAppServer default hasThings ifFalse: 
		[GbtCompiler new parse: self things]! !

!BuddyWallet methodsFor: 'test data' stamp: 'hk 4/27/2017 18:43'!
installUsers
	GbtBizAppServer default isCompiled ifTrue: [^self].  "do it only once"
	#(Tom Lisa) do: [:u| GbtBizAppServer default addUser: u withRole: 
			(GbtRole forExecute 
				addFilter: '#firstName = ''',u asString, '''' for: #MyAccounts;
				addFilter: '#senderName = ''',u asString, '''' for: #Transfers) ].
	#(Tony Robert) do: [:u| GbtBizAppServer default addUser: u withRole: (GbtRole forWrite )].
	#(Bob) do: [:u| GbtBizAppServer default addUser: u withRole: (GbtRole forRead )]
! !

!BuddyWallet methodsFor: 'contexts' stamp: 'hk 4/27/2017 17:50'!
login
	^ GbtLoginAC
		struct: 'BuddyWalletLogin'
		define:
			{{#uiSpec:icon: . nil . #walletBig}.
			{#displayAs: . #BuddyWallet}.
			{#appClass:selector: . #BuddyWallet . #buddyWallet}.
			{#legalText: . 'GloConn International © 2016'}}! !

!BuddyWallet methodsFor: 'contexts' stamp: 'hk 3/21/2017 14:23'!
myAccountContext  
	^GbtPlainAC struct: 'MyAccountContext' define: {
		{#displayAs: . 'MyAccount'  } .
		{#uiSpec:icon: . #GbtItemUI . #contacts}.
	}! !

!BuddyWallet methodsFor: 'contexts' stamp: 'hk 3/21/2017 14:23'!
myAccounts  
	^GbtBigListAC struct: 'MyAccounts' define: {
		{#displayAs: . 'MyAccounts'} .
		{#noPolicyPrefix: . 'Acc'}.
		{#uiSpec:icon: . #GbtListAndItemUI . #contacts} .
		{#templates: . self account} .
		{#loadPolicy: . #autoload } .
		{#display: . #(#(nick nickName)  amount IBAN)} .
		{#subcontext: . self myAccountContext}}! !

!BuddyWallet methodsFor: 'test data' stamp: 'hk 3/20/2017 18:05'!
nextBizID
	^GbtBizAppServer default nextIdOfContextNoPolicy: #MyAccounts! !

!BuddyWallet methodsFor: 'test data' stamp: 'hk 4/28/2017 11:04'!
storeAccounts
	"creates the noPolicy for the test data"
	GbtBizAppServer default contextNoPolicyOf: #MyAccounts prefix: #Acc	.
	self account01 storeAll.
	self account02 storeAll.
	self account03 storeAll. 
	self account04 storeAll.
	self account05 storeAll! !

!BuddyWallet methodsFor: 'things' stamp: 'hk 4/28/2017 13:17'!
things
^'
	thing Contact 
		{ 
		*val firstName 		:  ''''
		*val lastName  		:  ''''
		*val eMail     		:  '''' 					
		val phone     		:  '''' 
		}
		
	thing Account 
		summary 				:  ''#firstName #nick'' 
		{ 
		*val nick 			:  soleAccount 
		*val IBAN 			:  '''' 
		*no amount 			:  0 
		*val currency 		:  EUR
		*no dispo 			:  0 
		*no transferLimit 	:  1000 
		*thing person 		:  Contact
		}

	thing TransferOrder
		summary 				:  ''transfer order template''
		{ 
		*val senderName  	:  ''''
		*no transferAmount :  0 
		*val currency 		:  EUR 
		val source 			: ''''
		val target 			: ''''
		val date 				: ''''
		}		
'! !

!BuddyWallet methodsFor: 'contexts' stamp: 'hk 4/27/2017 17:51'!
transferContext 
	self declaratives .
	^GbtPlainAC struct: 'TransferContext' define: {
		{#displayAs: . 'TransferOrder'  } .
		{#uiSpec:icon: . #GbtItemUI . #wallet}.
		{#txThings: . #(transferSource transferSink) }.
		{#chooseFor:use:from: . #source . #nick . self myAccounts}.
		{#chooseFor:use:from: . #target . #eMail . self buddies }.
		{#menu: . #doit}.
		{#behavior: . self doitBehavior: #doit}.
		{#createBehaviors: . #(userName) }.
		{#behavior:actions: . #userName . #(ASSIGNUSER senderName)}.
	}! !

!BuddyWallet methodsFor: 'things' stamp: 'hk 4/28/2017 12:50'!
transferOrder
	"self new transferOrder"
	self ensureCompilation . 
	^GbtThing copy: 'TransferOrder'! !

!BuddyWallet methodsFor: 'contexts' stamp: 'hk 3/21/2017 14:24'!
transfers 
	^GbtBigListAC struct: 'Transfers' define: {
		{#displayAs: . 'Transfers'} .
		{#noPolicyPrefix: . 'MTF'}.
		{#uiSpec:icon: . #GbtListAndItemUI . #wallet} .
		{#templates: . self transferOrder} .
		{#loadPolicy: . #autoload } .
		{#display: . #( #(senderName von) #(transferAmount amount) currency #(source von) #(target an))} .
		{#subcontext: . self transferContext}.
	}! !

!BuddyWallet methodsFor: 'things' stamp: 'hk 4/28/2017 12:16'!
xaccount
| contact |
contact := GbtThing struct: 'Contact' define: {
		{ #firstName . #val: . ''}.
		{ #lastName . #val: . ''}.
		{ #eMail . #val: . '' }.					
		{ #phone .  #val: . '' } 
	}.
		^GbtThing struct: 'Account' define: {
		{ #summary . '#firstName #nick' }.
		{ #nick . #val: . #soleAccount }.
		{ #IBAN . #val: . '' }.
		{ #amount . #no: . 0 }.
		{ #currency .  #val: . 'EUR' } .
		{ #dispo . #no: . 0 }.
		{ #transferLimit . #no: . 1000 }.
		{ #person . #thing: . contact}.
	}! !

!BuddyWallet methodsFor: 'things' stamp: 'hk 4/28/2017 12:16'!
xtransferOrder
	^GbtThing struct: 'TransferOrder' define: {
		{ #summary . 'transfer order template' }.
		{ #senderName . #val: . ''}.
		{ #transferAmount . #no: . 0 }.
		{ #currency .  #val: . 'EUR' } .
	} full: { 
		{ #source .  #val: . '' }.
		{ #target .  #val: . '' }.
		{ #date .  #date: . ''}.
	}! !
